/***************************************************************************
                          configfile.cpp  -  description
                             -------------------
    begin                : za aug 9 2003
    copyright            : (C) 2003 by meilof
    email                : meilof@athlon
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <poslib/poslib.h>
#include <gtk/gtk.h>
#include "interface.h"
#include "main.h"
#include "support.h"
#include "getdnsservers.cpp"
#include "callbacks.h"

#ifdef _WIN32
#define PATHDELIM "\\"
#define PATHDELIMC '\\'
#else
#define PATHDELIM "/"
#define PATHDELIMC '/'
#endif

char dnsqueryrc[PATH_MAX] = "";
stl_list(stl_string) os_dns_servers;
stl_list(stl_string) qnames;
stl_list(stl_string) servers;
stl_string last_server, last_type, orig_type;

#define MAXSERVERS 10
#define MAXQNAMES 10

void update_recent_servers() {
  GList *lservers = NULL;
  stl_list(stl_string)::iterator it;
  stl_string tmp;

  lservers = g_list_append(lservers, (gpointer)"127.0.0.1");

  /* append system resolvers */
  try {
    stl_slist(_addr) sys = get_os_dns_servers();
    stl_slist(_addr)::iterator it = sys.begin();
    while (it != sys.end()) {
      tmp = addr_to_string(&*it);
      lservers = g_list_append(lservers, (gpointer)tmp.c_str());
      os_dns_servers.push_back(tmp);
      it++;
    }
  } catch (PException p) { }
  lservers = g_list_append(lservers, (gpointer)"-");
  it = servers.begin();
  while (it != servers.end()) {
    lservers = g_list_append(lservers, (gpointer)it->c_str());
    it++;
  }
  if (lservers) gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget(frmMain, "combo2")), lservers);
  g_list_free (lservers);
}  

void update_recent_qnames() {
  GList *lqnames = NULL;

  stl_list(stl_string)::iterator it;

  it = qnames.begin();
  while (it != qnames.end()) {
    lqnames = g_list_append(lqnames, (gpointer)it->c_str());
    it++;
  }
  if (lqnames) gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget(frmMain, "combo1")), lqnames);
  g_list_free (lqnames);
}


void read_data() {
  char *ptr = getenv("DNSQUERYRC");

  if (ptr && strlen(ptr) < sizeof(dnsqueryrc)) {
    strcpy(dnsqueryrc, ptr);
  } else {
#ifdef _WIN32
    ptr = getenv("USERPROFILE"); /* windows 2k/xp */
    if (ptr && strlen(ptr) < sizeof(dnsqueryrc)) {
      strcpy(dnsqueryrc, ptr);
    } else if (GetWindowsDirectory(dnsqueryrc, PATH_MAX) == 0) {
      dnsqueryrc[0] = 0;
    }
    if (dnsqueryrc[0]) {
      if (strlen(dnsqueryrc) + strlen("dnsqueryrc.txt") + 1 < sizeof(dnsqueryrc)) {
        if (dnsqueryrc[strlen(dnsqueryrc) - 1] != '\\') strcat(dnsqueryrc, "\\");
        strcat(dnsqueryrc, "dnsqueryrc.txt");
      } else {
        dnsqueryrc[0] = 0;
      }
    }
#else
    char *ptr = getenv("HOME");
    if (ptr && strlen(ptr) + strlen(".dnsqueryrc") + 1 < sizeof(dnsqueryrc)) {
      strcpy(dnsqueryrc, ptr);
      if (dnsqueryrc[strlen(dnsqueryrc) - 1] != PATHDELIMC) strcat(dnsqueryrc, PATHDELIM);
      strcat(dnsqueryrc, ".dnsqueryrc");
    }
#endif
  }
  if (dnsqueryrc[0]) {
    FILE *f = try_fopen_r(dnsqueryrc);
    char *ptr;
    char buff[PATH_MAX];
    if (f) {
      while (!feof(f)) {
        if (fgets(buff, sizeof(buff), f)) {
          /* remove newlines */
          ptr = buff + strlen(buff) - 1;
          while ((*ptr == '\n' || *ptr == '\r') && ptr >= buff) {
            *ptr = '\0';
          }
          /* check for name=value pairs */
          if ( (ptr = strchr(buff, '=')) != NULL ) {
            *ptr = '\0'; ptr++;

            if (strcmpi(buff, "qname") == 0) {
              qnames.push_back(ptr);
            } else if (strcmpi(buff, "server") == 0) {
              servers.push_back(ptr);
            } else if (strcmpi(buff, "last_server") == 0) {
              last_server = ptr;
            } else if (strcmpi(buff, "last_type") == 0) {
              last_type = ptr;
            }
          }
        }
      }
    }
  }

  update_recent_servers();
  update_recent_qnames();
  if (last_server != "")
    gtk_entry_set_text(GTK_ENTRY(lookup_widget(frmMain, "txtServer")), last_server.c_str());
  if (last_type != "")
  gtk_entry_set_text(GTK_ENTRY(lookup_widget(frmMain, "txtType")), last_type.c_str());
  txttype_changed = false;
  orig_type = last_type;
}

void add_to_recentservers(const char *server) {
  stl_list(stl_string)::iterator it;

  /* check whether it's an OS dns server */
  it = os_dns_servers.begin();
  while (it != os_dns_servers.end()) {
    if (strcmpi(it->c_str(), server) == 0) return;
    it++;
  }

  stl_string str;
  stl_string srv = server;
  it = servers.begin();
  while (it != servers.end()) {
    if (strcmpi(server, it->c_str()) == 0) {
      /* push to front */
      str = *it;
      servers.erase(it);
      servers.push_front(str);
      update_recent_servers();
      gtk_entry_set_text(GTK_ENTRY(lookup_widget(frmMain, "txtServer")), srv.c_str());
      return;
    }
    it++;
  }
  /* new one */
  if (strcmp(server, "127.0.0.1") != 0) {
    if (servers.size() >= MAXSERVERS) servers.pop_back();
    servers.push_front(server);
  }
  update_recent_servers();
  gtk_entry_set_text(GTK_ENTRY(lookup_widget(frmMain, "txtServer")), srv.c_str());
}

void add_to_recentqnames(const char *qname) {
  stl_list(stl_string)::iterator it;
  stl_string str;
  stl_string qnm = qname;
  it = qnames.begin();
  while (it != qnames.end()) {
    if (strcmpi(qname, it->c_str()) == 0) {
      /* push to front */
      str = *it;
      qnames.erase(it);
      qnames.push_front(str);
      update_recent_qnames();
      gtk_entry_set_text(GTK_ENTRY(lookup_widget(frmMain, "txtDom")), qnm.c_str());
      return;
    }
    it++;
  }
  /* new one */
  if (qnames.size() >= MAXQNAMES) qnames.pop_back();
  qnames.push_front(qname);
  update_recent_qnames();
  gtk_entry_set_text(GTK_ENTRY(lookup_widget(frmMain, "txtDom")), qnm.c_str());
}

void write_data() {
  /* write the dnsqueryrc */
  if (dnsqueryrc[0]) {
    FILE *f = try_fopen(dnsqueryrc, "w");
    if (f) {
      stl_list(stl_string)::iterator it;

      it = qnames.begin();
      while (it != qnames.end()) {
        fprintf(f, "qname=%s\n", it->c_str());
        it++;
      }

      it = servers.begin();
      while (it != servers.end()) {
        fprintf(f, "server=%s\n", it->c_str());
        it++;
      }

      fprintf(f, "last_server=%s\n", last_server.c_str());
      fprintf(f, "last_type=%s\n", last_type.c_str());
    }
  }
}
