/*
 * WIJZIG DIT BESTAND NIET - het is gegenereerd door Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget*
create_frmMain (void)
{
  GtkWidget *frmMain;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *label1;
  GtkWidget *combo1;
  GtkWidget *txtDom;
  GtkWidget *hbox2;
  GtkWidget *label2;
  GtkWidget *combo2;
  GtkWidget *txtServer;
  GtkWidget *label3;
  GtkWidget *combo3;
  GList *combo3_items = NULL;
  GtkWidget *txtType;
  GtkWidget *cmdQuery;
  GtkWidget *cmdOptions;
  GtkWidget *hseparator1;
  GtkWidget *scrolledwindow1;
  GtkWidget *viewport1;
  GtkWidget *lstAnswer;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  frmMain = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (frmMain), "frmMain", frmMain);
  gtk_window_set_title (GTK_WINDOW (frmMain), "DNS query tool");
  gtk_window_set_default_size (GTK_WINDOW (frmMain), 400, 250);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frmMain), vbox1);

  hbox1 = gtk_hbox_new (FALSE, 2);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 1);

  label1 = gtk_label_new ("Domain name: ");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, FALSE, 0);

  combo1 = gtk_combo_new ();
  gtk_widget_ref (combo1);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "combo1", combo1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo1);
  gtk_box_pack_start (GTK_BOX (hbox1), combo1, TRUE, TRUE, 0);

  txtDom = GTK_COMBO (combo1)->entry;
  gtk_widget_ref (txtDom);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "txtDom", txtDom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txtDom);
  gtk_tooltips_set_tip (tooltips, txtDom, "Server to query (optionally followed by '#<port>')", NULL);

  hbox2 = gtk_hbox_new (FALSE, 2);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 1);

  label2 = gtk_label_new ("Server: ");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox2), label2, FALSE, FALSE, 0);

  combo2 = gtk_combo_new ();
  gtk_widget_ref (combo2);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "combo2", combo2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo2);
  gtk_box_pack_start (GTK_BOX (hbox2), combo2, TRUE, TRUE, 0);

  txtServer = GTK_COMBO (combo2)->entry;
  gtk_widget_ref (txtServer);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "txtServer", txtServer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txtServer);
  gtk_tooltips_set_tip (tooltips, txtServer, "Server to query (optionally followed by '#<port>')", NULL);
  gtk_entry_set_text (GTK_ENTRY (txtServer), "127.0.0.1");

  label3 = gtk_label_new (" Type: ");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox2), label3, FALSE, FALSE, 0);

  combo3 = gtk_combo_new ();
  gtk_widget_ref (combo3);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "combo3", combo3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo3);
  gtk_box_pack_start (GTK_BOX (hbox2), combo3, TRUE, TRUE, 0);
  combo3_items = g_list_append (combo3_items, (gpointer) "A - IPv4 address");
  combo3_items = g_list_append (combo3_items, (gpointer) "AAAA - IPv6 address");
  combo3_items = g_list_append (combo3_items, (gpointer) "NS - Nameserver");
  combo3_items = g_list_append (combo3_items, (gpointer) "MX - Mail server");
  combo3_items = g_list_append (combo3_items, (gpointer) "PTR - Pointer");
  combo3_items = g_list_append (combo3_items, (gpointer) "ANY - Any record");
  combo3_items = g_list_append (combo3_items, (gpointer) " -");
  combo3_items = g_list_append (combo3_items, (gpointer) "SOA - Star of Authority");
  combo3_items = g_list_append (combo3_items, (gpointer) "SRV - Service");
  combo3_items = g_list_append (combo3_items, (gpointer) "TXT - Free-form text");
  combo3_items = g_list_append (combo3_items, (gpointer) "CNAME - Alias");
  combo3_items = g_list_append (combo3_items, (gpointer) "HINFO - Host information");
  combo3_items = g_list_append (combo3_items, (gpointer) " - ");
  combo3_items = g_list_append (combo3_items, (gpointer) "AXFR - Zone transfer");
  combo3_items = g_list_append (combo3_items, (gpointer) "(type in your own)");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo3), combo3_items);
  g_list_free (combo3_items);

  txtType = GTK_COMBO (combo3)->entry;
  gtk_widget_ref (txtType);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "txtType", txtType,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txtType);
  gtk_tooltips_set_tip (tooltips, txtType, "Query type. Either choose one from the list or type in your own RR type or decimal QTYPE.", NULL);
  gtk_entry_set_text (GTK_ENTRY (txtType), "A - IPv4 address");

  cmdQuery = gtk_button_new_with_label ("Query!");
  gtk_widget_ref (cmdQuery);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "cmdQuery", cmdQuery,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cmdQuery);
  gtk_box_pack_start (GTK_BOX (hbox2), cmdQuery, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, cmdQuery, "Perform/stop query", NULL);
  gtk_widget_add_accelerator (cmdQuery, "clicked", accel_group,
                              GDK_Return, 0,
                              GTK_ACCEL_VISIBLE);

  cmdOptions = gtk_button_new_with_label ("Advanced...");
  gtk_widget_ref (cmdOptions);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "cmdOptions", cmdOptions,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cmdOptions);
  gtk_box_pack_start (GTK_BOX (hbox2), cmdOptions, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, cmdOptions, "Set query options", NULL);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, TRUE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport1), GTK_SHADOW_NONE);

  lstAnswer = gtk_list_new ();
  gtk_widget_ref (lstAnswer);
  gtk_object_set_data_full (GTK_OBJECT (frmMain), "lstAnswer", lstAnswer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lstAnswer);
  gtk_container_add (GTK_CONTAINER (viewport1), lstAnswer);

  gtk_signal_connect (GTK_OBJECT (frmMain), "delete_event",
                      GTK_SIGNAL_FUNC (on_frmMain_destroy_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (txtDom), "changed",
                      GTK_SIGNAL_FUNC (on_txtDom_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (txtType), "changed",
                      GTK_SIGNAL_FUNC (on_txtType_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cmdQuery), "clicked",
                      GTK_SIGNAL_FUNC (on_cmdQuery_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cmdOptions), "clicked",
                      GTK_SIGNAL_FUNC (on_cmdOptions_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (lstAnswer), "selection_get",
                      GTK_SIGNAL_FUNC (on_lstAnswer_selection_get),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (frmMain), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (frmMain), accel_group);

  return frmMain;
}

GtkWidget*
create_mnuOptions (void)
{
  GtkWidget *mnuOptions;
  GtkAccelGroup *mnuOptions_accels;
  GtkWidget *mnuOptionsAdvanced;
  GtkWidget *mnuOptionsRecursion;
  GtkWidget *mnuOptionsClipboard;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  mnuOptions = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (mnuOptions), "mnuOptions", mnuOptions);
  mnuOptions_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (mnuOptions));

  mnuOptionsAdvanced = gtk_check_menu_item_new_with_label ("Advanced view");
  gtk_widget_ref (mnuOptionsAdvanced);
  gtk_object_set_data_full (GTK_OBJECT (mnuOptions), "mnuOptionsAdvanced", mnuOptionsAdvanced,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnuOptionsAdvanced);
  gtk_container_add (GTK_CONTAINER (mnuOptions), mnuOptionsAdvanced);
  gtk_tooltips_set_tip (tooltips, mnuOptionsAdvanced, "Show the raw answer DNS message", NULL);
  gtk_check_menu_item_set_show_toggle (GTK_CHECK_MENU_ITEM (mnuOptionsAdvanced), TRUE);

  mnuOptionsRecursion = gtk_check_menu_item_new_with_label ("Request recursion");
  gtk_widget_ref (mnuOptionsRecursion);
  gtk_object_set_data_full (GTK_OBJECT (mnuOptions), "mnuOptionsRecursion", mnuOptionsRecursion,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnuOptionsRecursion);
  gtk_container_add (GTK_CONTAINER (mnuOptions), mnuOptionsRecursion);
  gtk_tooltips_set_tip (tooltips, mnuOptionsRecursion, "Whether to set the RD (recursion desired) flag in queries", NULL);
  gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (mnuOptionsRecursion), TRUE);
  gtk_check_menu_item_set_show_toggle (GTK_CHECK_MENU_ITEM (mnuOptionsRecursion), TRUE);

  mnuOptionsClipboard = gtk_menu_item_new_with_label ("Copy to clipboard");
  gtk_widget_ref (mnuOptionsClipboard);
  gtk_object_set_data_full (GTK_OBJECT (mnuOptions), "mnuOptionsClipboard", mnuOptionsClipboard,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnuOptionsClipboard);
  gtk_container_add (GTK_CONTAINER (mnuOptions), mnuOptionsClipboard);
  gtk_tooltips_set_tip (tooltips, mnuOptionsClipboard, "Copy the contents to the clipboard", NULL);

  gtk_signal_connect (GTK_OBJECT (mnuOptionsAdvanced), "activate",
                      GTK_SIGNAL_FUNC (on_mnuOptionsAdvanced_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mnuOptionsRecursion), "activate",
                      GTK_SIGNAL_FUNC (on_mnuOptionsRecursion_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mnuOptionsClipboard), "activate",
                      GTK_SIGNAL_FUNC (on_mnuOptionsClipboard_activate),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (mnuOptions), "tooltips", tooltips);

  return mnuOptions;
}

