/***************************************************************************
                          thread.cpp  -  query thread
                             -------------------
    begin                : di feb 25 2003
    copyright            : (C) 2003 by meilof
    email                : meilof@athlon
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "thread.h"
#include "main.h"
#include "callbacks.h"
#include "support.h"
#include "answertostring.cpp"

#include <gtk/gtk.h>

bool query_busy = false;
bool disable_answer_output = false;
DnsMessage *q = NULL;
_addr qserver;

pos_cliresolver res;

void query_stop() {
  res.stop();
}

#ifdef _WIN32
gboolean fn(gpointer arg) {
  if (disable_answer_output) { free((char*)arg); return FALSE; }
  char *text = (char *)arg;
  GtkWidget *la = lookup_widget(frmMain, "lstAnswer");
  GtkWidget *li = gtk_list_item_new_with_label(text);
  lstData += text; lstData += "\n";
  free(text);
  gtk_container_add(GTK_CONTAINER(la), li);
  gtk_widget_show(li);
  return FALSE;
}

gboolean fn2(gpointer arg) {
  stl_list(stl_string)* lst = (stl_list(stl_string)*) arg;
  stl_list(stl_string)::iterator it = lst->begin();
  GtkWidget *li;
  
  if (disable_answer_output) { delete lst; return FALSE; }
  GtkWidget *la = lookup_widget(frmMain, "lstAnswer");
  
  while (it != lst->end()) {
    li = gtk_list_item_new_with_label(it->c_str());
    gtk_container_add(GTK_CONTAINER(la), li);
    lstData += it->c_str();
    lstData += "\n";
    gtk_widget_show(li);
    it++;
  }
  delete lst;
  return FALSE;
}
#endif

void add_line_to_list(GtkList *List, const char *text) {
#ifdef _WIN32
  g_idle_add_full(G_PRIORITY_HIGH, fn, strdup(text), NULL);
#else
  if (disable_answer_output) return;
  GtkWidget *li = gtk_list_item_new_with_label(text);
  gtk_container_add(GTK_CONTAINER(List), li);
  lstData += text; lstData += "\n";
  gtk_widget_show(li);
#endif
}

void add_lines_to_list(GtkList *List, stl_list(stl_string) strings) {
#ifdef _WIN32
  stl_list(stl_string) *list2 = new stl_list(stl_string)(strings);
  g_idle_add_full(G_PRIORITY_HIGH_IDLE, fn2, list2, NULL);
#else
  if (disable_answer_output) return;
  stl_list(stl_string)::iterator it = strings.begin();
  while (it != strings.end()) {
    GtkWidget *li = gtk_list_item_new_with_label(it->c_str());
    lstData += it->c_str(); lstData += "\n";
    gtk_container_add(GTK_CONTAINER(List), li);
    gtk_widget_show(li);
    it++;
  }
#endif
}

void *querythread(void *nulldata) {
  DnsMessage *a = NULL;
  GtkList *gt;
  bool entered = false, do_tcp = (q->questions.begin()->QTYPE == QTYPE_AXFR);
  stl_list(stl_string) answerstring;
  postime_t begin, end;
  
  try {
    begin = getcurtime();
    if (do_tcp) {
      /* use tcp */
      int sockid = res.tcpconnect(&qserver);
      res.tcpquery(q, a, sockid);
      res.tcpdisconnect(sockid);
    } else {
      res.query(q, a, &qserver);
    }
    end = getcurtime();
#ifdef _WIN32
    GDK_THREADS_ENTER();
#else
    gdk_threads_enter();
#endif
    entered = true;
    gt = (GtkList *)lookup_widget(frmMain, "lstAnswer");
    if (GTK_CHECK_MENU_ITEM(lookup_widget(mnuOptions, "mnuOptionsAdvanced"))->active) {
      add_lines_to_list(gt, answer_to_advanced_string(a, gtk_entry_get_text(GTK_ENTRY(lookup_widget(frmMain, "txtServer"))), do_tcp, end.after(begin)));
    } else {
      add_lines_to_list(gt, answer_to_simple_string(a, gtk_entry_get_text(GTK_ENTRY(lookup_widget(frmMain, "txtServer")))));
    }
  } catch (PException p) {
#ifdef _WIN32
    if (!entered) GDK_THREADS_ENTER();
#else
    if (!entered) gdk_threads_enter();
#endif
    gt = (GtkList *)lookup_widget(frmMain, "lstAnswer");
    add_line_to_list(GTK_LIST(gt), "*** Error: ***");
    add_line_to_list(GTK_LIST(gt), p.message);
  }
  query_busy = false;
  gtk_label_set_text(GTK_LABEL(GTK_BIN(lookup_widget(frmMain, "cmdQuery"))->child), "Query!");
#ifdef _WIN32
  GDK_THREADS_LEAVE();
#else    
  gdk_threads_leave();
#endif
  if (a) delete a;
  return NULL;
}
